//
//  ScrollTimer2ViewController.m
//  ScrollTimer2
//
//  Created by Fima on 4/26/10.
//  Copyright mls-automatization 2010. All rights reserved.
//

#import "ScrollTimer2ViewController.h"
#import <QuartzCore/QuartzCore.h>
#import "TimerScrollView.h"
@implementation ScrollTimer2ViewController



/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	instance = self;
	self.view.backgroundColor = [UIColor whiteColor];

	TimerScrollView *sv = [[TimerScrollView alloc] initWithFrame:[UIScreen mainScreen].bounds];
	[self.view addSubview:sv];
	
	//adding red label
	redTimerLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 0, 200, 25)];
	redTimerLabel.backgroundColor = [UIColor redColor];
	[self.view addSubview:redTimerLabel];
	redTime = 0;

	timeStamp = 1.0;

	[self startTimer];
}
-(void) startTimer
{
	//simple timer
	//[NSTimer scheduledTimerWithTimeInterval:timeStamp target:self selector:@selector(setRedLabelText) userInfo:nil repeats:YES];
	
	//timer with userInfo parameter
	/*CABasicAnimation * obj = [CABasicAnimation animationWithKeyPath:@"position"];
	 [obj setValue:@"userInfo" forKey:@"text"];
	 [obj setValue:[NSNumber numberWithInt:756] forKey:@"value"];
	 [NSTimer scheduledTimerWithTimeInterval:timeStamp target:self selector:@selector(setRedLabelTextFromTimer:) userInfo:obj repeats:YES];*/
	
	//timer with invocation
	/*SEL selector = @selector(setRedLabelTextWithText::);
	NSMethodSignature *signature = [ScrollTimer2ViewController instanceMethodSignatureForSelector:selector];
	NSInvocation *invocation = [NSInvocation invocationWithMethodSignature:signature];
	[invocation setSelector:selector];
	NSString *str = @"userInfo";
	[str retain];
	int val = 756;
	[invocation setTarget:self];
	[invocation setArgument:&str atIndex:2];
	[invocation setArgument:&val atIndex:3];
	[NSTimer scheduledTimerWithTimeInterval:timeStamp invocation:invocation repeats:YES];
	[str release];*/
	
	
	
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	[NSThread detachNewThreadSelector:@selector(launchTimer) toTarget:self withObject:nil];
	[pool release];
}

-(void)launchTimer{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	[NSThread setThreadPriority:1.0];
	continuePlaying = YES;
	while (continuePlaying) 
	{  
		[NSThread sleepForTimeInterval:timeStamp];
		//[self performSelectorOnMainThread:@selector(setRedLabelText) withObject:nil waitUntilDone:NO];
		SEL selector = @selector(setRedLabelTextWithText::);
		NSMethodSignature *signature = [ScrollTimer2ViewController instanceMethodSignatureForSelector:selector];
		NSInvocation *invocation = [NSInvocation invocationWithMethodSignature:signature];
		[invocation setSelector:selector];
		NSString *str = @"userInfo";
		[str retain];
		int val = 756;
		[invocation setTarget:instance];
		[invocation setArgument:&str atIndex:2];
		[invocation setArgument:&val atIndex:3];
		[invocation performSelectorOnMainThread:@selector(invoke) withObject:nil waitUntilDone:NO];
	}
	[pool release];
}

#pragma mark -
#pragma mark - red label
-(void) setRedLabelText
{
	redTime+=timeStamp;
	NSString *str = [[NSString alloc] initWithFormat:@"%.2f", redTime];
	redTimerLabel.text = str;
	[str release];
}

-(void) setRedLabelTextFromTimer:(NSTimer *) timer
{
	redTime+=timeStamp;
	NSString *text = [[NSString alloc] initWithFormat:@"%.2f %@ = %d", redTime, [[timer userInfo] valueForKey:@"text"], [[[timer userInfo] valueForKey:@"value"] intValue]];
	redTimerLabel.text = text;
	[text release];
}

-(void) setRedLabelTextWithText:(NSString *) str : (int) value
{
	redTime+=timeStamp;
	NSString *text = [[NSString alloc] initWithFormat:@"%.2f %@ = %d", redTime, str, value];
	redTimerLabel.text = text;
	[text release];
}



/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

@end
