//
//  TimerScrollView.m
//  ScrollTimer
//
//  Created by Fima on 4/16/10.
//  Copyright 2010 mls-automatization. All rights reserved.
//

#import "TimerScrollView.h"


@implementation TimerScrollView


- (id)initWithFrame:(CGRect)frame {
    if ((self = [super initWithFrame:frame])) {
		self.scrollEnabled = YES;
		self.delegate = self;
		self.minimumZoomScale = 0.1f;
		self.maximumZoomScale = 5.0f;
		imageView = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"image0.jpg"]];
		[self addSubview:imageView];
		[self setContentSize:CGSizeMake(imageView.frame.size.width, imageView.frame.size.height)];
    }
    return self;
}

- (UIView *)viewForZoomingInScrollView:(UIScrollView *)scrollView
{
	return imageView;
}

- (void)scrollViewDidEndZooming:(UIScrollView *)scrollView withView:(UIView *)view atScale:(float)scale
{
}


- (void)dealloc {
    [super dealloc];
}


@end
